import { defineComponent, watch, ref, openBlock, createElementBlock, withDirectives, createElementVNode, normalizeStyle, toDisplayString, pushScopeId, popScopeId } from "vue";
var index_vue_vue_type_style_index_0_scoped_true_lang = "";
var _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const _withScopeId = (n) => (pushScopeId("data-v-7099ca3a"), n = n(), popScopeId(), n);
const _hoisted_1 = { style: { "position": "relative" } };
const _hoisted_2 = /* @__PURE__ */ _withScopeId(() => /* @__PURE__ */ createElementVNode("svg", {
  id: "svg-container",
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg"
}, null, -1));
const _sfc_main = /* @__PURE__ */ defineComponent({
  props: {
    text: {
      type: String,
      default: ""
    },
    highLight: {
      type: Array,
      default: []
    },
    fontSize: {
      type: String,
      default: "20px"
    },
    lineHeight: {
      type: String,
      default: "1.8em"
    },
    letterSpacing: {
      type: String,
      default: "4px"
    },
    fillColor: {
      type: String,
      default: "yellow"
    },
    fillOpacity: {
      type: String,
      default: "0.6"
    }
  },
  emits: ["ifError"],
  setup(__props, { emit }) {
    const props = __props;
    const createDom = () => {
      let text = props.text, index2 = 0, domHtml = "";
      for (let i = 0; i < text.length; i++) {
        if (text[i] === "\n") {
          domHtml = domHtml + `<span>${text[i]}</span>`;
          index2++;
        } else {
          domHtml = domHtml + `<span id="sf-${i + index2}">${text[i]}</span>`;
        }
      }
      let domContainer = document.getElementById("dom-container");
      domContainer.innerHTML = "";
      domContainer.innerHTML = domHtml;
    };
    const createHighLight = () => {
      let svgContainer = document.getElementById("svg-container"), domContainer = document.getElementById("dom-container");
      svgContainer.style.height = domContainer.clientHeight;
      svgContainer.innerHTML = "";
      let container = svgContainer.getBoundingClientRect();
      let highLightData = props.highLight, fillColor = props.fillColor, fillOpacity = props.fillOpacity;
      try {
        for (let opt of highLightData) {
          let start = document.getElementById(`sf-${opt.start}`), end = document.getElementById(`sf-${opt.end}`), startLocation = start.getBoundingClientRect(), endLocation = end.getBoundingClientRect();
          let svgNS = "http://www.w3.org/2000/svg";
          if (startLocation.y === endLocation.y) {
            let oSvg = document.createElementNS(svgNS, "rect");
            oSvg.setAttribute("x", startLocation.x - container.x + "");
            oSvg.setAttribute("y", startLocation.y - container.y + "");
            oSvg.setAttribute("width", endLocation.x + endLocation.width - startLocation.x - 4 + "");
            oSvg.setAttribute("height", startLocation.height);
            oSvg.setAttribute("fill-opacity", fillOpacity);
            oSvg.setAttribute("fill", fillColor);
            svgContainer.append(oSvg);
          } else {
            let line = (endLocation.y - startLocation.y) / 120;
            line--;
            for (line; line > 0; line--) {
              let aSvg = document.createElementNS(svgNS, "rect");
              aSvg.setAttribute("x", "0");
              aSvg.setAttribute("y", startLocation.y + 96 * line - container.y + "");
              aSvg.setAttribute("width", container.width - 4 + "");
              aSvg.setAttribute("height", startLocation.height);
              aSvg.setAttribute("fill-opacity", fillOpacity);
              aSvg.setAttribute("fill", fillColor);
              svgContainer.append(aSvg);
            }
            let sSvg = document.createElementNS(svgNS, "rect");
            sSvg.setAttribute("x", startLocation.x - container.x + "");
            sSvg.setAttribute("y", startLocation.y - container.y + "");
            sSvg.setAttribute("width", container.x + container.width - startLocation.x - 4 + "");
            sSvg.setAttribute("height", startLocation.height);
            sSvg.setAttribute("fill-opacity", fillOpacity);
            sSvg.setAttribute("fill", fillColor);
            svgContainer.append(sSvg);
            let eSvg = document.createElementNS(svgNS, "rect");
            eSvg.setAttribute("x", "0");
            eSvg.setAttribute("y", endLocation.y - container.y + "");
            eSvg.setAttribute("width", endLocation.x + endLocation.width - container.x - 4 + "");
            eSvg.setAttribute("height", startLocation.height);
            eSvg.setAttribute("fill-opacity", fillOpacity);
            eSvg.setAttribute("fill", fillColor);
            svgContainer.append(eSvg);
          }
        }
      } catch (e) {
        console.error("[error]\u9AD8\u4EAE\u4F4D\u7F6E\u6709\u8BEF\uFF0C\u8BF7\u68C0\u67E5");
        emit("ifError");
      }
    };
    watch(() => props.text, () => {
      createDom();
      createHighLight();
    });
    watch(() => props.highLight, () => {
      createHighLight();
    }, { deep: true });
    const vContainerWidthChange = {
      mounted(el, binding) {
        function debounce(fn, delay = 16) {
          let t = null;
          return function() {
            if (t) {
              clearTimeout(t);
            }
            const context = this;
            const args = arguments;
            t = setTimeout(() => {
              fn.apply(context, args);
            }, delay);
          };
        }
        el._resizer = new window.ResizeObserver(debounce(binding.value, Number(binding.arg) || 16));
        el._resizer.observe(el);
      },
      unmounted(el) {
        el._resizer.disconnect();
      }
    };
    const widthTemp = ref(null);
    const onResize = () => {
      var _a;
      let domContainer = document.getElementById("dom-container");
      if (widthTemp.value !== domContainer.clientWidth) {
        (_a = widthTemp.value) != null ? _a : widthTemp.value = domContainer.clientWidth;
        createDom();
        createHighLight();
      }
    };
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1, [
        _hoisted_2,
        withDirectives(createElementVNode("div", {
          id: "dom-container",
          class: "container",
          style: normalizeStyle({ fontSize: __props.fontSize, lineHeight: __props.lineHeight, letterSpacing: __props.letterSpacing })
        }, null, 4), [
          [vContainerWidthChange, onResize, "50"]
        ]),
        createElementVNode("div", {
          id: "text-container",
          class: "container",
          style: normalizeStyle({ fontSize: __props.fontSize, lineHeight: __props.lineHeight, letterSpacing: __props.letterSpacing })
        }, toDisplayString(__props.text), 5)
      ]);
    };
  }
});
var index = /* @__PURE__ */ _export_sfc(_sfc_main, [["__scopeId", "data-v-7099ca3a"]]);
export { index as Highlight };
